#maze game
from scene import *
import math

class MyScene (Scene):
	def setup(self):
		self.bgdata = [
			"11111111111111111111",
			"1 1     1   1      1",
			"1   111 1 1 1111 1 1",
			"11111     1 1    1 1",
			"1   11111 1 1 1111 1",
			"1 1   1   1 1    1 1",
			"111 1   1 1   11 1 1",
			"1   11111 111 11 1 1",
			"1 1  1      1 1  1 1",
			"11111111111111111111"]		
		self.background_color = 'black'
		self.chipsize = 32
		ground = Node(parent=self)
		for y in range(10):
			for x in range(20):
				if (self.bgdata[y][x]==" "): continue
				tile = SpriteNode('block.png')
				tmpx = self.chipsize*x+(self.chipsize/2)
				tmpy = self.size.h-(self.chipsize*y)-(self.chipsize/2)
				tile.position = (tmpx, tmpy)
				ground.add_child(tile)
				
		box = SpriteNode('box.png')
		self.boxx = self.chipsize*18+(self.chipsize/2)
		self.boxy = self.chipsize*8+(self.chipsize/2)
		box.position = (self.boxx,self.size.h-self.boxy)
		ground.add_child(box)
		self.player = SpriteNode('man.png')
		self.player.position = (0, 0)
		self.player.x = self.chipsize*1+(self.chipsize/2)
		self.player.y = self.chipsize*1+(self.chipsize/2)
		self.player.walking = 0
		self.add_child(self.player)
		self.msg = ' '
		self.tx=-1
		self.ty=-1
	
	def update(self):
		x = self.player.x
		y = self.player.y
		self.player.position = (x, self.size.h-y)
		if (self.player.walking==0):
			if self.tx>0 or self.ty>0:
				dx=self.tx-self.player.position.x
				dy=self.ty-self.player.position.y
				degree = math.degrees(math.atan2(-dy,dx))
				if degree<0:degree += 360
				degree = int((degree+45)/90)*90
				self.x1 = int(math.cos(math.radians(degree)))
				self.y1 = int(math.sin(math.radians(degree)))
				newx = int(x/self.chipsize)+self.x1
				newy = int(y/self.chipsize)+self.y1
				if (self.bgdata[newy][newx]==" "):
					self.player.walking = 1
					
				self.tx = -1
				self.ty = -1
		else:
			x += self.x1
			y += self.y1
			self.player.x = x
			self.player.y = y
			tmpx = (x-(self.chipsize/2)) % self.chipsize
			tmpy = (y-(self.chipsize/2)) % self.chipsize
			if (tmpx==0) and (tmpy==0):
				self.player.walking=0
			if (x == self.boxx) and (y == self.boxy):
				self.msg = "GOAL!"
				
		text(self.msg, font_size=48, x=300, y=400)

	def touch_began(self,touch):
		self.tx,self.ty = touch.location		

run(MyScene())
